"branch -d" can remove more than one branches
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
28a94f88 46unset EMAIL
95a1d12e
JN
47unset $(perl -e '
48 my @env = keys %ENV;
730477f1
JL
49 my $ok = join("|", qw(
50 TRACE
51 DEBUG
52 USE_LOOKUP
53 TEST
54 .*_TEST
55 PROVE
56 VALGRIND
57 ));
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
59 print join("\n", @vars);
60')
29e55cd5
JH
61GIT_AUTHOR_EMAIL=author@example.com
62GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
63GIT_COMMITTER_EMAIL=committer@example.com
64GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f
SP
65GIT_MERGE_VERBOSITY=5
66export GIT_MERGE_VERBOSITY
29e55cd5
JH
67export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 69export EDITOR
e1970ce4 70
886a3907
JH
71# Protect ourselves from common misconfiguration to export
72# CDPATH into the environment
73unset CDPATH
74
5565f47c
BW
75unset GREP_OPTIONS
76
3d5c0cc9 77case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
78 1|2|true)
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
83 ;;
84esac
85
cd3c095c
JH
86# Convenience
87#
88# A regexp to match 5 and 40 hexdigits
89_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
91
3749fde5
JH
92# Zero SHA-1
93_z40=0000000000000000000000000000000000000000
94
e1970ce4
JH
95# Each test should start with something like this, after copyright notices:
96#
97# test_description='Description of this test...
98# This test checks if command xyzzy does the right thing...
99# '
100# . ./test-lib.sh
c2116a17
JH
101[ "x$ORIGINAL_TERM" != "xdumb" ] && (
102 TERM=$ORIGINAL_TERM &&
103 export TERM &&
104 [ -t 1 ] &&
105 tput bold >/dev/null 2>&1 &&
106 tput setaf 1 >/dev/null 2>&1 &&
107 tput sgr0 >/dev/null 2>&1
108 ) &&
55db1df0 109 color=t
e1970ce4 110
e1970ce4
JH
111while test "$#" -ne 0
112do
113 case "$1" in
114 -d|--d|--de|--deb|--debu|--debug)
115 debug=t; shift ;;
886856ab
JH
116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t; shift ;;
5e2c08c6 118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 119 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 120 -h|--h|--he|--hel|--help)
570f3226 121 help=t; shift ;;
e1970ce4
JH
122 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
123 verbose=t; shift ;;
1ece1274 124 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
125 # Ignore --quiet under a TAP::Harness. Saying how many tests
126 # passed without the ok/not ok details is always an error.
127 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
128 --with-dashes)
129 with_dashes=t; shift ;;
55db1df0 130 --no-color)
faa4bc35 131 color=; shift ;;
4e1be63c 132 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 133 valgrind=t; verbose=t; shift ;;
44138559
JS
134 --tee)
135 shift ;; # was handled already
f423ef5f
JK
136 --root=*)
137 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
138 shift ;;
e1970ce4 139 *)
1f729dca 140 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
141 esac
142done
143
55db1df0
PH
144if test -n "$color"; then
145 say_color () {
c2116a17
JH
146 (
147 TERM=$ORIGINAL_TERM
148 export TERM
55db1df0
PH
149 case "$1" in
150 error) tput bold; tput setaf 1;; # bold red
151 skip) tput bold; tput setaf 2;; # bold green
152 pass) tput setaf 2;; # green
153 info) tput setaf 3;; # brown
1ece1274 154 *) test -n "$quiet" && return;;
55db1df0
PH
155 esac
156 shift
5099b99d 157 printf "%s" "$*"
55db1df0 158 tput sgr0
b8eecafd 159 echo
c2116a17 160 )
55db1df0
PH
161 }
162else
163 say_color() {
1ece1274 164 test -z "$1" && test -n "$quiet" && return
55db1df0 165 shift
5099b99d 166 echo "$*"
55db1df0
PH
167 }
168fi
169
170error () {
171 say_color error "error: $*"
6e7b5aaf 172 GIT_EXIT_OK=t
55db1df0
PH
173 exit 1
174}
175
176say () {
177 say_color info "$*"
178}
179
570f3226
MB
180test "${test_description}" != "" ||
181error "Test script did not set test_description."
182
183if test "$help" = "t"
184then
185 echo "$test_description"
186 exit 0
187fi
188
4d9d62fa 189exec 5>&1
e1970ce4
JH
190if test "$verbose" = "t"
191then
192 exec 4>&2 3>&1
193else
194 exec 4>/dev/null 3>/dev/null
195fi
196
197test_failure=0
198test_count=0
41ac414e
JH
199test_fixed=0
200test_broken=0
2d84e9fb 201test_success=0
e1970ce4 202
d998bd4a
ÆAB
203test_external_has_tap=0
204
faa4bc35 205die () {
6e7b5aaf
CB
206 code=$?
207 if test -n "$GIT_EXIT_OK"
208 then
209 exit $code
210 else
211 echo >&5 "FATAL: Unexpected exit with code $code"
212 exit 1
213 fi
faa4bc35
CB
214}
215
6e7b5aaf 216GIT_EXIT_OK=
35641310 217trap 'die' EXIT
41184273 218
02b35660
BD
219# The semantics of the editor variables are that of invoking
220# sh -c "$EDITOR \"$@\"" files ...
221#
222# If our trash directory contains shell metacharacters, they will be
223# interpreted if we just set $EDITOR directly, so do a little dance with
224# environment variables to work around this.
225#
226# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 227# that we're using.
02b35660
BD
228test_set_editor () {
229 FAKE_EDITOR="$1"
230 export FAKE_EDITOR
d33738d7
JN
231 EDITOR='"$FAKE_EDITOR"'
232 export EDITOR
02b35660
BD
233}
234
68cfc6f5 235test_decode_color () {
a471833d
KB
236 awk '
237 function name(n) {
238 if (n == 0) return "RESET";
239 if (n == 1) return "BOLD";
240 if (n == 30) return "BLACK";
241 if (n == 31) return "RED";
242 if (n == 32) return "GREEN";
243 if (n == 33) return "YELLOW";
244 if (n == 34) return "BLUE";
245 if (n == 35) return "MAGENTA";
246 if (n == 36) return "CYAN";
247 if (n == 37) return "WHITE";
248 if (n == 40) return "BLACK";
249 if (n == 41) return "BRED";
250 if (n == 42) return "BGREEN";
251 if (n == 43) return "BYELLOW";
252 if (n == 44) return "BBLUE";
253 if (n == 45) return "BMAGENTA";
254 if (n == 46) return "BCYAN";
255 if (n == 47) return "BWHITE";
256 }
257 {
c2ed29b4 258 while (match($0, /\033\[[0-9;]*m/) != 0) {
a471833d
KB
259 printf "%s<", substr($0, 1, RSTART-1);
260 codes = substr($0, RSTART+2, RLENGTH-3);
261 if (length(codes) == 0)
262 printf "%s", name(0)
263 else {
264 n = split(codes, ary, ";");
265 sep = "";
266 for (i = 1; i <= n; i++) {
267 printf "%s%s", sep, name(ary[i]);
268 sep = ";"
269 }
270 }
271 printf ">";
272 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
273 }
274 print
275 }
276 '
68cfc6f5
MG
277}
278
9130ac9f
JK
279nul_to_q () {
280 perl -pe 'y/\000/Q/'
281}
282
c4f3f551
SB
283q_to_nul () {
284 perl -pe 'y/Q/\000/'
285}
286
287q_to_cr () {
288 tr Q '\015'
289}
290
800f1104
JN
291q_to_tab () {
292 tr Q '\011'
293}
294
c4f3f551
SB
295append_cr () {
296 sed -e 's/$/Q/' | tr Q '\015'
297}
298
299remove_cr () {
300 tr '\015' Q | sed -e 's/Q$//'
301}
302
00648ba0
EN
303# In some bourne shell implementations, the "unset" builtin returns
304# nonzero status when a variable to be unset was not set in the first
305# place.
306#
307# Use sane_unset when that should not be considered an error.
308
309sane_unset () {
310 unset "$@"
311 return 0
312}
313
04509738
JH
314test_tick () {
315 if test -z "${test_tick+set}"
316 then
21afc41c 317 test_tick=1112911993
04509738
JH
318 else
319 test_tick=$(($test_tick + 60))
320 fi
21afc41c
JH
321 GIT_COMMITTER_DATE="$test_tick -0700"
322 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
323 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
324}
e1970ce4 325
00884968
JS
326# Call test_commit with the arguments "<message> [<file> [<contents>]]"
327#
328# This will commit a file with the given contents and the given commit
329# message. It will also add a tag with <message> as name.
330#
331# Both <file> and <contents> default to <message>.
332
333test_commit () {
e656fc97 334 file=${2:-"$1.t"}
00884968
JS
335 echo "${3-$1}" > "$file" &&
336 git add "$file" &&
337 test_tick &&
338 git commit -m "$1" &&
339 git tag "$1"
340}
341
342# Call test_merge with the arguments "<message> <commit>", where <commit>
343# can be a tag pointing to the commit-to-merge.
344
345test_merge () {
346 test_tick &&
347 git merge -m "$1" "$2" &&
348 git tag "$1"
349}
350
1f553918
JS
351# This function helps systems where core.filemode=false is set.
352# Use it instead of plain 'chmod +x' to set or unset the executable bit
353# of a file in the working directory and add it to the index.
354
355test_chmod () {
356 chmod "$@" &&
357 git update-index --add "--chmod=$@"
358}
359
a7bb3940
JS
360# Use test_set_prereq to tell that a particular prerequisite is available.
361# The prerequisite can later be checked for in two ways:
362#
363# - Explicitly using test_have_prereq.
364#
365# - Implicitly by specifying the prerequisite tag in the calls to
366# test_expect_{success,failure,code}.
367#
368# The single parameter is the prerequisite tag (a simple word, in all
369# capital letters by convention).
370
371test_set_prereq () {
372 satisfied="$satisfied$1 "
373}
374satisfied=" "
375
376test_have_prereq () {
93a57246
ÆAB
377 # prerequisites can be concatenated with ','
378 save_IFS=$IFS
379 IFS=,
380 set -- $*
381 IFS=$save_IFS
ce60653e
ÆAB
382
383 total_prereq=0
384 ok_prereq=0
385 missing_prereq=
386
93a57246
ÆAB
387 for prerequisite
388 do
ce60653e 389 total_prereq=$(($total_prereq + 1))
93a57246
ÆAB
390 case $satisfied in
391 *" $prerequisite "*)
ce60653e
ÆAB
392 ok_prereq=$(($ok_prereq + 1))
393 ;;
93a57246 394 *)
ce60653e
ÆAB
395 # Keep a list of missing prerequisites
396 if test -z "$missing_prereq"
397 then
398 missing_prereq=$prerequisite
399 else
400 missing_prereq="$prerequisite,$missing_prereq"
401 fi
93a57246
ÆAB
402 esac
403 done
ce60653e
ÆAB
404
405 test $total_prereq = $ok_prereq
a7bb3940
JS
406}
407
05236a5e
JN
408test_declared_prereq () {
409 case ",$test_prereq," in
410 *,$1,*)
411 return 0
412 ;;
413 esac
414 return 1
415}
416
886856ab
JH
417# You are not expected to call test_ok_ and test_failure_ directly, use
418# the text_expect_* functions instead.
419
420test_ok_ () {
d5d9de1b 421 test_success=$(($test_success + 1))
5099b99d 422 say_color "" "ok $test_count - $@"
e1970ce4
JH
423}
424
886856ab 425test_failure_ () {
d5d9de1b 426 test_failure=$(($test_failure + 1))
5099b99d 427 say_color error "not ok - $test_count $1"
bf0dd8a8 428 shift
5099b99d 429 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 430 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
431}
432
41ac414e 433test_known_broken_ok_ () {
41ac414e 434 test_fixed=$(($test_fixed+1))
5099b99d 435 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
436}
437
438test_known_broken_failure_ () {
41ac414e 439 test_broken=$(($test_broken+1))
5099b99d 440 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 441}
886856ab
JH
442
443test_debug () {
8e832ebc 444 test "$debug" = "" || eval "$1"
e1970ce4
JH
445}
446
4d9d62fa 447test_run_ () {
b6b0afdc 448 test_cleanup=:
4d9d62fa 449 eval >&3 2>&4 "$1"
b6b0afdc 450 eval_ret=$?
3bf78867 451 eval >&3 2>&4 "$test_cleanup"
57e1538a
ÆAB
452 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
453 echo ""
454 fi
4d9d62fa
PR
455 return 0
456}
457
04ece593 458test_skip () {
8586f98b 459 test_count=$(($test_count+1))
04ece593
JH
460 to_skip=
461 for skp in $GIT_SKIP_TESTS
462 do
8586f98b 463 case $this_test.$test_count in
04ece593
JH
464 $skp)
465 to_skip=t
47e67d47 466 break
04ece593
JH
467 esac
468 done
05236a5e
JN
469 if test -z "$to_skip" && test -n "$test_prereq" &&
470 ! test_have_prereq "$test_prereq"
a7bb3940
JS
471 then
472 to_skip=t
473 fi
04ece593
JH
474 case "$to_skip" in
475 t)
07431fc8 476 of_prereq=
05236a5e 477 if test "$missing_prereq" != "$test_prereq"
07431fc8 478 then
05236a5e 479 of_prereq=" of $test_prereq"
07431fc8
JN
480 fi
481
55db1df0 482 say_color skip >&3 "skipping test: $@"
07431fc8 483 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
484 : true
485 ;;
486 *)
487 false
488 ;;
489 esac
490}
491
e1970ce4 492test_expect_failure () {
05236a5e 493 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 494 test "$#" = 2 ||
a7bb3940 495 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
05236a5e 496 export test_prereq
04ece593 497 if ! test_skip "$@"
e1970ce4 498 then
41ac414e 499 say >&3 "checking known breakage: $2"
04ece593 500 test_run_ "$2"
41ac414e 501 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 502 then
41ac414e 503 test_known_broken_ok_ "$1"
04ece593 504 else
6e7b5aaf 505 test_known_broken_failure_ "$1"
04ece593 506 fi
e1970ce4 507 fi
7a0cf2d0 508 echo >&3 ""
e1970ce4
JH
509}
510
511test_expect_success () {
05236a5e 512 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 513 test "$#" = 2 ||
a7bb3940 514 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
05236a5e 515 export test_prereq
04ece593 516 if ! test_skip "$@"
e1970ce4 517 then
04ece593
JH
518 say >&3 "expecting success: $2"
519 test_run_ "$2"
520 if [ "$?" = 0 -a "$eval_ret" = 0 ]
521 then
522 test_ok_ "$1"
523 else
524 test_failure_ "$@"
525 fi
e1970ce4 526 fi
7a0cf2d0 527 echo >&3 ""
e1970ce4
JH
528}
529
fb32c410
LW
530# test_external runs external test scripts that provide continuous
531# test output about their progress, and succeeds/fails on
532# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 533# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
534# <n>: ..." before running it. When providing relative paths, keep in
535# mind that all scripts run in "trash directory".
536# Usage: test_external description command arguments...
537# Example: test_external 'Perl API' perl ../path/to/test.pl
538test_external () {
05236a5e 539 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
a7bb3940
JS
540 test "$#" = 3 ||
541 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
542 descr="$1"
543 shift
05236a5e 544 export test_prereq
fb32c410
LW
545 if ! test_skip "$descr" "$@"
546 then
547 # Announce the script to reduce confusion about the
548 # test output that follows.
d998bd4a 549 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
550 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
551 # to be able to use them in script
552 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
553 # Run command; redirect its stderr to &4 as in
554 # test_run_, but keep its stdout on our stdout even in
555 # non-verbose mode.
556 "$@" 2>&4
557 if [ "$?" = 0 ]
558 then
d998bd4a
ÆAB
559 if test $test_external_has_tap -eq 0; then
560 test_ok_ "$descr"
561 else
562 say_color "" "# test_external test $descr was ok"
563 test_success=$(($test_success + 1))
564 fi
fb32c410 565 else
d998bd4a
ÆAB
566 if test $test_external_has_tap -eq 0; then
567 test_failure_ "$descr" "$@"
568 else
569 say_color error "# test_external test $descr failed: $@"
570 test_failure=$(($test_failure + 1))
571 fi
fb32c410
LW
572 fi
573 fi
574}
575
576# Like test_external, but in addition tests that the command generated
577# no output on stderr.
578test_external_without_stderr () {
579 # The temporary file has no (and must have no) security
580 # implications.
581 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
582 stderr="$tmp/git-external-stderr.$$.tmp"
583 test_external "$@" 4> "$stderr"
584 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
585 descr="no stderr: $1"
586 shift
d998bd4a 587 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
588 if [ ! -s "$stderr" ]; then
589 rm "$stderr"
d998bd4a
ÆAB
590
591 if test $test_external_has_tap -eq 0; then
592 test_ok_ "$descr"
593 else
594 say_color "" "# test_external_without_stderr test $descr was ok"
595 test_success=$(($test_success + 1))
596 fi
fb32c410
LW
597 else
598 if [ "$verbose" = t ]; then
d998bd4a 599 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
600 else
601 output=
602 fi
603 # rm first in case test_failure exits.
604 rm "$stderr"
d998bd4a
ÆAB
605 if test $test_external_has_tap -eq 0; then
606 test_failure_ "$descr" "$@" "$output"
607 else
608 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
609 test_failure=$(($test_failure + 1))
610 fi
fb32c410
LW
611 fi
612}
613
2caf20c5
MM
614# debugging-friendly alternatives to "test [-f|-d|-e]"
615# The commands test the existence or non-existence of $1. $2 can be
616# given to provide a more precise diagnosis.
617test_path_is_file () {
618 if ! [ -f "$1" ]
619 then
620 echo "File $1 doesn't exist. $*"
621 false
622 fi
623}
624
625test_path_is_dir () {
626 if ! [ -d "$1" ]
627 then
628 echo "Directory $1 doesn't exist. $*"
629 false
630 fi
631}
632
633test_path_is_missing () {
634 if [ -e "$1" ]
635 then
636 echo "Path exists:"
637 ls -ld "$1"
638 if [ $# -ge 1 ]; then
639 echo "$*"
640 fi
641 false
642 fi
643}
644
fb3340a6
JN
645# test_line_count checks that a file has the number of lines it
646# ought to. For example:
647#
648# test_expect_success 'produce exactly one line of output' '
649# do something >output &&
650# test_line_count = 1 output
651# '
652#
653# is like "test $(wc -l <output) = 1" except that it passes the
654# output through when the number of lines is wrong.
655
656test_line_count () {
657 if test $# != 3
658 then
659 error "bug in the test script: not 3 parameters to test_line_count"
660 elif ! test $(wc -l <"$3") "$1" "$2"
661 then
662 echo "test_line_count: line count for $3 !$1 $2"
663 cat "$3"
664 return 1
665 fi
666}
2caf20c5 667
74359821
JH
668# This is not among top-level (test_expect_success | test_expect_failure)
669# but is a prefix that can be used in the test script, like:
670#
671# test_expect_success 'complain and die' '
672# do something &&
673# do something else &&
674# test_must_fail git checkout ../outerspace
675# '
676#
677# Writing this as "! git checkout ../outerspace" is wrong, because
678# the failure could be due to a segv. We want a controlled failure.
679
680test_must_fail () {
681 "$@"
16034fbe
JK
682 exit_code=$?
683 if test $exit_code = 0; then
684 echo >&2 "test_must_fail: command succeeded: $*"
685 return 1
686 elif test $exit_code -gt 129 -a $exit_code -le 192; then
687 echo >&2 "test_must_fail: died by signal: $*"
688 return 1
a54ce3ca
JK
689 elif test $exit_code = 127; then
690 echo >&2 "test_must_fail: command not found: $*"
691 return 1
16034fbe
JK
692 fi
693 return 0
74359821
JH
694}
695
fdf1bc48
JN
696# Similar to test_must_fail, but tolerates success, too. This is
697# meant to be used in contexts like:
698#
699# test_expect_success 'some command works without configuration' '
700# test_might_fail git config --unset all.configuration &&
701# do something
702# '
703#
704# Writing "git config --unset all.configuration || :" would be wrong,
705# because we want to notice if it fails due to segv.
706
707test_might_fail () {
708 "$@"
5c8e1414
JN
709 exit_code=$?
710 if test $exit_code -gt 129 -a $exit_code -le 192; then
711 echo >&2 "test_might_fail: died by signal: $*"
712 return 1
d0b8a617
JN
713 elif test $exit_code = 127; then
714 echo >&2 "test_might_fail: command not found: $*"
715 return 1
5c8e1414
JN
716 fi
717 return 0
fdf1bc48
JN
718}
719
892e6f7e
ÆAB
720# Similar to test_must_fail and test_might_fail, but check that a
721# given command exited with a given exit code. Meant to be used as:
722#
723# test_expect_success 'Merge with d/f conflicts' '
724# test_expect_code 1 git merge "merge msg" B master
725# '
726
727test_expect_code () {
728 want_code=$1
729 shift
730 "$@"
731 exit_code=$?
732 if test $exit_code = $want_code
733 then
734 echo >&2 "test_expect_code: command exited with $exit_code: $*"
735 return 0
736 else
737 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
738 return 1
739 fi
740}
741
82ebb0b6
JK
742# test_cmp is a helper function to compare actual and expected output.
743# You can use it like:
744#
745# test_expect_success 'foo works' '
746# echo expected >expected &&
747# foo >actual &&
748# test_cmp expected actual
749# '
750#
751# This could be written as either "cmp" or "diff -u", but:
752# - cmp's output is not nearly as easy to read as diff -u
753# - not all diff versions understand "-u"
754
755test_cmp() {
756 $GIT_TEST_CMP "$@"
757}
758
3bf78867
JN
759# This function can be used to schedule some commands to be run
760# unconditionally at the end of the test to restore sanity:
761#
762# test_expect_success 'test core.capslock' '
763# git config core.capslock true &&
764# test_when_finished "git config --unset core.capslock" &&
765# hello world
766# '
767#
768# That would be roughly equivalent to
769#
770# test_expect_success 'test core.capslock' '
771# git config core.capslock true &&
772# hello world
773# git config --unset core.capslock
774# '
775#
776# except that the greeting and config --unset must both succeed for
777# the test to pass.
778
779test_when_finished () {
b6b0afdc
JN
780 test_cleanup="{ $*
781 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
782}
783
0509eb21 784# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
785# Usage: test_create_repo <directory>
786test_create_repo () {
787 test "$#" = 1 ||
788 error "bug in the test script: not 1 parameter to test-create-repo"
eedf8f97 789 repo="$1"
bfdbee98 790 mkdir -p "$repo"
0d314ce8
ÆAB
791 (
792 cd "$repo" || error "Cannot setup test environment"
793 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
794 error "cannot run git init -- have you built things yet?"
795 mv .git/hooks .git/hooks-disabled
796 ) || exit
eedf8f97 797}
a6080a0a 798
e1970ce4 799test_done () {
6e7b5aaf 800 GIT_EXIT_OK=t
2d84e9fb 801
8ef1abe5
ÆAB
802 if test -z "$HARNESS_ACTIVE"; then
803 test_results_dir="$TEST_DIRECTORY/test-results"
804 mkdir -p "$test_results_dir"
805 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
806
807 echo "total $test_count" >> $test_results_path
808 echo "success $test_success" >> $test_results_path
809 echo "fixed $test_fixed" >> $test_results_path
810 echo "broken $test_broken" >> $test_results_path
811 echo "failed $test_failure" >> $test_results_path
812 echo "" >> $test_results_path
813 fi
41ac414e
JH
814
815 if test "$test_fixed" != 0
816 then
5099b99d 817 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
818 fi
819 if test "$test_broken" != 0
820 then
5099b99d 821 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
822 msg="remaining $(($test_count-$test_broken)) test(s)"
823 else
824 msg="$test_count test(s)"
41ac414e 825 fi
e1970ce4 826 case "$test_failure" in
10b94e28 827 0)
5099b99d
ÆAB
828 # Maybe print SKIP message
829 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
830
d998bd4a
ÆAB
831 if test $test_external_has_tap -eq 0; then
832 say_color pass "# passed all $msg"
833 say "1..$test_count$skip_all"
834 fi
abc5d372
JS
835
836 test -d "$remove_trash" &&
837 cd "$(dirname "$remove_trash")" &&
838 rm -rf "$(basename "$remove_trash")"
839
e1970ce4
JH
840 exit 0 ;;
841
842 *)
d998bd4a
ÆAB
843 if test $test_external_has_tap -eq 0; then
844 say_color error "# failed $test_failure among $msg"
845 say "1..$test_count"
846 fi
5099b99d 847
e1970ce4
JH
848 exit 1 ;;
849
850 esac
851}
852
853# Test the binaries we have just built. The tests are kept in
9adefee5 854# t/ subdirectory and are run in 'trash directory' subdirectory.
62f53904
ÆAB
855if test -z "$TEST_DIRECTORY"
856then
857 # We allow tests to override this, in case they want to run tests
858 # outside of t/, e.g. for running tests on the test library
859 # itself.
860 TEST_DIRECTORY=$(pwd)
861fi
6cec5c68
ÆAB
862GIT_BUILD_DIR="$TEST_DIRECTORY"/..
863
e4597aae 864if test -n "$valgrind"
4e1be63c 865then
4e1be63c
JS
866 make_symlink () {
867 test -h "$2" &&
868 test "$1" = "$(readlink "$2")" || {
869 # be super paranoid
870 if mkdir "$2".lock
871 then
872 rm -f "$2" &&
873 ln -s "$1" "$2" &&
874 rm -r "$2".lock
875 else
876 while test -d "$2".lock
877 do
878 say "Waiting for lock on $2."
879 sleep 1
880 done
881 fi
882 }
883 }
884
885 make_valgrind_symlink () {
886 # handle only executables
887 test -x "$1" || return
888
889 base=$(basename "$1")
6cec5c68 890 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
891 # do not override scripts
892 if test -x "$symlink_target" &&
893 test ! -d "$symlink_target" &&
894 test "#!" != "$(head -c 2 < "$symlink_target")"
895 then
896 symlink_target=../valgrind.sh
897 fi
efd92ffd
JS
898 case "$base" in
899 *.sh|*.perl)
900 symlink_target=../unprocessed-script
901 esac
4e1be63c
JS
902 # create the link, or replace it if it is out of date
903 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
904 }
905
906 # override all git executables in TEST_DIRECTORY/..
907 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
908 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 909 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
910 do
911 make_valgrind_symlink $file
912 done
efd92ffd
JS
913 OLDIFS=$IFS
914 IFS=:
915 for path in $PATH
916 do
917 ls "$path"/git-* 2> /dev/null |
918 while read file
919 do
920 make_valgrind_symlink "$file"
921 done
922 done
923 IFS=$OLDIFS
4e1be63c
JS
924 PATH=$GIT_VALGRIND/bin:$PATH
925 GIT_EXEC_PATH=$GIT_VALGRIND/bin
926 export GIT_VALGRIND
e4597aae
MO
927elif test -n "$GIT_TEST_INSTALLED" ; then
928 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
929 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 930 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
931 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
932else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 933 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
e4597aae
MO
934 if ! test -x "$git_bin_dir/git" ; then
935 if test -z "$with_dashes" ; then
936 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
937 fi
938 with_dashes=t
939 fi
940 PATH="$git_bin_dir:$PATH"
6cec5c68 941 GIT_EXEC_PATH=$GIT_BUILD_DIR
e4597aae 942 if test -n "$with_dashes" ; then
6cec5c68 943 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 944 fi
4e1be63c 945fi
6cec5c68 946GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 947unset GIT_CONFIG
8bfa6bd6 948GIT_CONFIG_NOSYSTEM=1
3c995beb 949GIT_ATTR_NOSYSTEM=1
8f323c00 950export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 951
aed604c7 952. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
ac10a857 953
5e87eae9
JH
954if test -z "$GIT_TEST_CMP"
955then
956 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
957 then
958 GIT_TEST_CMP="$DIFF -c"
959 else
960 GIT_TEST_CMP="$DIFF -u"
961 fi
962fi
963
6cec5c68 964GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 965export GITPERLLIB
6cec5c68 966test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
967 error "You haven't built things yet, have you?"
968}
e1970ce4 969
ac10a857 970if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 971then
6cec5c68 972 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 973 export GITPYTHONLIB
6cec5c68 974 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
975 error "You haven't built git_remote_helpers yet, have you?"
976 }
977fi
978
6cec5c68 979if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
56cf9806
EW
980 echo >&2 'You need to build test-chmtime:'
981 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
982 exit 1
983fi
984
e1970ce4 985# Test repository
abc5d372 986test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
987test -n "$root" && test="$root/$test"
988case "$test" in
989/*) TRASH_DIRECTORY="$test" ;;
990 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
991esac
91c8b825 992test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 993rm -fr "$test" || {
6e7b5aaf 994 GIT_EXIT_OK=t
8d14ac94
JH
995 echo >&5 "FATAL: Cannot prepare test area"
996 exit 1
997}
998
90cff968
AR
999HOME="$TRASH_DIRECTORY"
1000export HOME
1001
4a7aaccd 1002test_create_repo "$test"
1bd9c648
LW
1003# Use -P to resolve symlinks in our working directory so that the cwd
1004# in subprocesses like git equals our $PWD (for pathname comparisons).
1005cd -P "$test" || exit 1
04ece593 1006
d5d9de1b
JS
1007this_test=${0##*/}
1008this_test=${this_test%%-*}
04ece593
JH
1009for skp in $GIT_SKIP_TESTS
1010do
47e67d47
MG
1011 case "$this_test" in
1012 $skp)
55db1df0 1013 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 1014 skip_all="skip all tests in $this_test"
04ece593
JH
1015 test_done
1016 esac
1017done
f17e9fbb 1018
8648732e
BC
1019# Provide an implementation of the 'yes' utility
1020yes () {
1021 if test $# = 0
1022 then
1023 y=y
1024 else
1025 y="$*"
1026 fi
1027
1028 while echo "$y"
1029 do
1030 :
1031 done
1032}
1033
f17e9fbb
JS
1034# Fix some commands on Windows
1035case $(uname -s) in
1036*MINGW*)
1037 # Windows has its own (incompatible) sort and find
1038 sort () {
1039 /usr/bin/sort "$@"
1040 }
1041 find () {
1042 /usr/bin/find "$@"
1043 }
5397ea31
JS
1044 sum () {
1045 md5sum "$@"
1046 }
4114156a
JS
1047 # git sees Windows-style pwd
1048 pwd () {
1049 builtin pwd -W
1050 }
ee9fb68c 1051 # no POSIX permissions
6fd1106a 1052 # backslashes in pathspec are converted to '/'
fb9a2bea 1053 # exec does not inherit the PID
a94114ad 1054 test_set_prereq MINGW
a31d0665
RJ
1055 test_set_prereq SED_STRIPS_CR
1056 ;;
1057*CYGWIN*)
1058 test_set_prereq POSIXPERM
a31d0665
RJ
1059 test_set_prereq EXECKEEPSPID
1060 test_set_prereq NOT_MINGW
1061 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
1062 ;;
1063*)
1064 test_set_prereq POSIXPERM
6fd1106a 1065 test_set_prereq BSLASHPSPEC
fb9a2bea 1066 test_set_prereq EXECKEEPSPID
3ba9ba8f 1067 test_set_prereq NOT_MINGW
f17e9fbb
JS
1068 ;;
1069esac
704a3143 1070
1b19ccd2 1071test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 1072test -z "$NO_PYTHON" && test_set_prereq PYTHON
1b19ccd2 1073
bb946bba 1074# Can we rely on git's output in the C locale?
30955229
JN
1075if test -n "$GETTEXT_POISON"
1076then
1077 GIT_GETTEXT_POISON=YesPlease
1078 export GIT_GETTEXT_POISON
1079else
1080 test_set_prereq C_LOCALE_OUTPUT
1081fi
bb946bba 1082
cabdee2c
JH
1083# Use this instead of test_cmp to compare files that contain expected and
1084# actual output from git commands that can be translated. When running
1085# under GETTEXT_POISON this pretends that the command produced expected
1086# results.
1087test_i18ncmp () {
1088 test -n "$GETTEXT_POISON" || test_cmp "$@"
1089}
1090
127df8c6
JH
1091# Use this instead of "grep expected-string actual" to see if the
1092# output from a git command that can be translated either contains an
1093# expected string, or does not contain an unwanted one. When running
1094# under GETTEXT_POISON this pretends that the command produced expected
1095# results.
1096test_i18ngrep () {
1097 if test -n "$GETTEXT_POISON"
1098 then
1099 : # pretend success
1100 elif test "x!" = "x$1"
1101 then
1102 shift
1103 ! grep "$@"
1104 else
1105 grep "$@"
1106 fi
1107}
1108
704a3143
JS
1109# test whether the filesystem supports symbolic links
1110ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1111rm -f y
c91cfd19
ÆAB
1112
1113# When the tests are run as root, permission tests will report that
1114# things are writable when they shouldn't be.
1115test -w / || test_set_prereq SANITY